﻿using NUnit.Framework;

namespace Magify.Tests
{
    internal partial class MagifyClientTests
    {
        public class Dispose
        {
            [SetUp]
            [TearDown]
            public void ClearAllData()
            {
                EditorModeTestsEnvironment.Clear();
            }

            [Test]
            [UnitTestTarget(typeof(MagifyClient), nameof(MagifyClient.Dispose))]
            public void Create_Dispose_Recreate()
            {
                using (CreateDefault())
                {
                }
                using (CreateDefault())
                {
                }
            }

            [Test]
            public void Create_Initialize_Dispose_Recreate()
            {
                using (var client = CreateDefault())
                {
                    client.InitializeSdk();
                }
                using (CreateDefault())
                {
                }
            }

            [Test]
            public void Create_Initialize_Dispose_Recreate_Initialize()
            {
                using (var client = CreateDefault())
                {
                    client.InitializeSdk();
                }
                using (var client = CreateDefault())
                {
                    client.InitializeSdk();
                }
            }

            [Test]
            public void Create_InitializeSetup_Dispose_Recreate()
            {
                using (CreateDefaultAndInit())
                {
                }
                using (CreateDefault())
                {
                }
            }

            [Test]
            public void Create_InitializeSetup_Dispose_Recreate_InitializeSetup()
            {
                using (CreateDefaultAndInit())
                {
                }
                using (CreateDefaultAndInit())
                {
                }
            }

            [Test]
            public void Create_InitializeSetup_Dispose_ClearAllData_Recreate_InitializeSetup()
            {
                using (CreateDefaultAndInit())
                {
                }
                EditorModeTestsEnvironment.Clear();
                using (CreateDefaultAndInit())
                {
                }
            }
        }
    }
}