﻿namespace Magify.Tests
{
    internal partial class MagifyClientTests
    {
        private const string AppName = "TestApp";
        private const string ConfigPath = "";
        private const Environment OfflineEnvironment = Environment.Offline;

        private static MagifyClient CreateDefault()
        {
            return new MagifyClient(AppName, ConfigPath, EditorModeTestsEnvironment.RootStoragePath, null, OfflineEnvironment);
        }

        private static MagifyClient CreateDefaultAndInit()
        {
            var client = new MagifyClient(AppName, ConfigPath, EditorModeTestsEnvironment.RootStoragePath, null, OfflineEnvironment);
            client.InitializeSdk();
            client.Setup();
            return client;
        }

        private static CampaignsTracker GetCampaignsTracker(MagifyClient magifyClient)
        {
            return GetPrivateField<CampaignsTracker>(magifyClient, "_campaignsTracker");
        }

        private static AnalyticsTracker GetAnalyticsTracker(MagifyClient magifyClient)
        {
            return GetPrivateField<AnalyticsTracker>(magifyClient, "_analyticsTracker");
        }

        private static PlatformAPI GetPlatformAPI(MagifyClient magifyClient)
        {
            return GetPrivateField<PlatformAPI>(magifyClient, "_platform");
        }

        private static GeneralPrefs GetGeneralPrefs(MagifyClient magifyClient)
        {
            return GetPrivateField<GeneralPrefs>(magifyClient, "_generalPrefs");
        }

        private static SessionCounter GetSessionCounter(MagifyClient magifyClient)
        {
            return GetPrivateField<SessionCounter>(magifyClient, "_sessionCounter");
        }

        private static T GetPrivateField<T>(MagifyClient client, string fieldName)
            where T : class
        {
            return client
                    .GetType()
                    .GetField(fieldName, System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance)
                    !.GetValue(client)
                    as T;
        }
    }
}